PAT1091

1091 Acute Stroke (30分)

One important factor to identify acute stroke (急性脑卒中) is the volume of the stroke core. Given the results of image analysis in which the core regions are identified in each MRI slice, your job is to calculate the volume of the stroke core.

Input Specification:

Each input file contains one test case. For each case, the first line contains 4 positive integers: MNL and T, where M and N are the sizes of each slice (i.e. pixels of a slice are in an M×Nmatrix, and the maximum resolution is 1286 by 128); L (≤) is the number of slices of a brain; and T is the integer threshold (i.e. if the volume of a connected core is less than T, then that core must not be counted).

Then L slices are given. Each slice is represented by an M×N matrix of 0's and 1's, where 1 represents a pixel of stroke, and 0 means normal. Since the thickness of a slice is a constant, we only have to count the number of 1's to obtain the volume. However, there might be several separated core regions in a brain, and only those with their volumes no less than T are counted. Two pixels are connected and hence belong to the same region if they share a common side, as shown by Figure 1 where all the 6 red pixels are connected to the blue one.

figstroke.jpg

Figure 1

Output Specification:

For each case, output in a line the total volume of the stroke core.

Sample Input:

3 4 5 2
1 1 1 1
1 1 1 1
1 1 1 1
0 0 1 1
0 0 1 1
0 0 1 1
1 0 1 1
0 1 0 0
0 0 0 0
1 0 1 1
0 0 0 0
0 0 0 0
0 0 0 1
0 0 0 1
1 0 0 0
			

Sample Output:

26
			
BFS,DFS的话容易段错误
#include<iostream>
#include<queue>
using namespace std;
struct nod
{
	int x, y, z;
}node;
int pos[1290][130][61];
bool inq[1290][130][61] = {false};
int m, n, l, t;
int X[] = { 0,0,0,0,1,-1 };
int Y[] = { 0,0,1,-1,0,0 };
int Z[] = { 1,-1,0,0,0,0 };
bool judge(int x,int y,int z)
{
	if (x<0 || y<0 || z<0 || x>=m || y>=n || z>=l)return false;
	if (inq[x][y][z] == true||pos[x][y][z]!=1)return false;
	return true;
}
int BFS(int x, int y, int z)
{
	int ant = 0;
	queue<nod>q;
	node.x = x; node.y = y; node.z = z;
	q.push(node);
	inq[x][y][z] = true;
	while (!q.empty())
	{
		nod temp = q.front();
		q.pop();
		ant++;
		for (int i = 0; i < 6; i++)
		{

			int nowx = temp.x + X[i];
			int nowy = temp.y + Y[i];
			int nowz = temp.z + Z[i];
			if (judge(nowx, nowy, nowz))
			{
				node.x = nowx; node.y = nowy; node.z = nowz;
				q.push(node);
				inq[nowx][nowy][nowz] = true;
			}
		}
	}
	if (ant >= t)return ant;
  else return 0;//不满足条件时记得返回0,因为要计算和
}
int main()
{
	cin >> m >> n >> l >> t;
	for (int z = 0; z < l; z++)
		for (int x = 0; x < m; x++)
			for (int y = 0; y < n; y++)
				cin >> pos[x][y][z];
	int ans = 0;
	for (int z = 0; z < l; z++)
		for (int x = 0; x < m; x++)
			for (int y = 0; y < n; y++)
				if (pos[x][y][z] == 1 && inq[x][y][z] == false)
					ans += BFS(x, y, z);
	cout << ans << endl;
	return 0;
}


代码学习笔记 文章被收录于专栏

学习笔记,pat,牛客

全部评论

相关推荐

1 收藏 评论
分享
牛客网
牛客企业服务